'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _drawer = require('antd/lib/drawer');

var _drawer2 = _interopRequireDefault(_drawer);

var _modal = require('antd/lib/modal');

var _modal2 = _interopRequireDefault(_modal);

var _button = require('antd/lib/button');

var _button2 = _interopRequireDefault(_button);

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

require('antd/lib/drawer/style/css');

require('antd/lib/modal/style/css');

require('antd/lib/button/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _listHoc = require('../../components/listHoc');

var _listHoc2 = _interopRequireDefault(_listHoc);

var _icons = require('@ant-design/icons');

var Icons = _interopRequireWildcard(_icons);

var _utils = require('../../base/utils');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } /**
                                                                                                                                                                                                                              * Updated by Tw93 on 2019-12-01.
                                                                                                                                                                                                                              * 数组组件
                                                                                                                                                                                                                              */

function FrButton(_ref) {
  var icon = _ref.icon,
      children = _ref.children,
      rest = _objectWithoutProperties(_ref, ['icon', 'children']);

  var iconName = void 0;
  switch (icon) {
    case 'add':
      iconName = 'PlusCircleOutlined';
      break;
    case 'delete':
      iconName = 'DeleteOutlined';
      break;
    default:
      iconName = icon;
      break;
  }
  var IconComponent = Icons[iconName];
  if (IconComponent) {
    return _react2.default.createElement(
      _button2.default,
      _extends({}, rest, { size: 'small', icon: _react2.default.createElement(IconComponent, null) }),
      children
    );
  }
  return _react2.default.createElement(
    _button2.default,
    _extends({}, rest, { size: 'small' }),
    children
  );
}

var List = (0, _listHoc2.default)(FrButton);

var ListWithModal = function ListWithModal(props) {
  var _ref2 = props || {},
      options = _ref2.options,
      schema = _ref2.schema,
      value = _ref2.value;

  var arrLength = value && value.length || 0;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      show = _useState2[0],
      setShow = _useState2[1];

  var toggle = function toggle() {
    return setShow(function (o) {
      return !o;
    });
  };
  if (options && options.modal) {
    var config = (0, _utils.isObj)(options.modal) ? options.modal : {};
    var text = config.text;

    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        'a',
        { className: 'pointer', onClick: toggle },
        text && typeof text === 'string' ? '+ ' + text : '+ 配置'
      ),
      _react2.default.createElement(
        'span',
        null,
        '\uFF08',
        arrLength,
        '\u6761\u6570\u636E\uFF09'
      ),
      _react2.default.createElement(
        _modal2.default,
        _extends({
          title: schema && schema.title || '子配置',
          visible: show,
          onCancel: toggle,
          onOk: toggle,
          cancelText: '\u5173\u95ED',
          width: '80%'
        }, config, {
          style: _extends({ maxWidth: 800 }, config.style)
        }),
        _react2.default.createElement(
          'div',
          { className: 'fr-wrapper' },
          _react2.default.createElement(List, props)
        )
      )
    );
  }
  if (options && options.drawer) {
    var _config = (0, _utils.isObj)(options.drawer) ? options.drawer : {};
    var _text = _config.text;

    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        'a',
        { className: 'pointer', onClick: toggle },
        _text && typeof _text === 'string' ? '+ ' + _text : '+ 配置'
      ),
      _react2.default.createElement(
        _drawer2.default,
        _extends({
          title: schema && schema.title || '子配置',
          visible: show,
          onClose: toggle,
          width: '80%'
        }, _config),
        _react2.default.createElement(
          'div',
          { className: 'fr-wrapper' },
          _react2.default.createElement(List, props)
        )
      )
    );
  }
  return _react2.default.createElement(List, props);
};

exports.default = ListWithModal;