'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _drawer = require('antd/lib/drawer');

var _drawer2 = _interopRequireDefault(_drawer);

var _modal = require('antd/lib/modal');

var _modal2 = _interopRequireDefault(_modal);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

require('antd/lib/drawer/style/css');

require('antd/lib/modal/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utils = require('../../base/utils');

var _map = require('../../components/map');

var _map2 = _interopRequireDefault(_map);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MapWithModal = function MapWithModal(props) {
  var _ref = props || {},
      _ref$options = _ref.options,
      options = _ref$options === undefined ? {} : _ref$options,
      schema = _ref.schema;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      show = _useState2[0],
      setShow = _useState2[1];

  var toggle = function toggle() {
    return setShow(function (o) {
      return !o;
    });
  };
  if (options && options.modal) {
    var config = (0, _utils.isObj)(options.modal) ? options.modal : {};
    var text = config.text;

    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        'a',
        { className: 'pointer', onClick: toggle },
        text && typeof text === 'string' ? '+ ' + text : '+ 配置'
      ),
      _react2.default.createElement(
        _modal2.default,
        _extends({
          title: schema && schema.title || '子配置',
          visible: show,
          onCancel: toggle,
          footer: null,
          width: '80%'
        }, config, {
          style: _extends({ maxWidth: 800 }, config.style)
        }),
        _react2.default.createElement(_map2.default, props)
      )
    );
  }
  if (options && options.drawer) {
    var _config = (0, _utils.isObj)(options.drawer) ? options.drawer : {};
    var _text = _config.text;

    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        'a',
        { className: 'pointer', onClick: toggle },
        _text && typeof _text === 'string' ? '+ ' + _text : '+ 配置'
      ),
      _react2.default.createElement(
        _drawer2.default,
        _extends({
          title: schema && schema.title || '子配置',
          visible: show,
          onClose: toggle,
          width: '80%'
        }, _config),
        _react2.default.createElement(_map2.default, props)
      )
    );
  }
  return _react2.default.createElement(_map2.default, props);
};

exports.default = MapWithModal;