'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = color;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcColorPicker = require('rc-color-picker');

var _rcColorPicker2 = _interopRequireDefault(_rcColorPicker);

var _next = require('@alifd/next');

require('rc-color-picker/assets/index.css');

var _color = require('color');

var _color2 = _interopRequireDefault(_color);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function color(p) {
  var format = p.schema.format;

  var defaultColor = '#ffffff';
  var onPickerChange = function onPickerChange(e) {
    if (p.disabled || p.readonly) return;
    var color = e.color,
        alpha = e.alpha;

    if (alpha !== 100) {
      color = (0, _color2.default)(color).alpha(alpha / 100).string();
    }
    p.onChange(p.name, color);
  };
  var onInputChange = function onInputChange(value) {
    p.onChange(p.name, value);
  };

  return _react2.default.createElement(
    'div',
    { className: 'fr-color-picker' },
    _react2.default.createElement(_rcColorPicker2.default, {
      type: format,
      animation: 'slide-up',
      color: p.value || defaultColor,
      onClose: onPickerChange
    }),
    p.readonly ? _react2.default.createElement(
      'span',
      null,
      p.value || defaultColor
    ) : _react2.default.createElement(_next.Input, {
      style: { width: '100%' },
      placeholder: defaultColor,
      disabled: p.disabled,
      value: p.value,
      onChange: onInputChange
    })
  );
}