'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _next = require('@alifd/next');

var _listHoc = require('../../components/listHoc');

var _listHoc2 = _interopRequireDefault(_listHoc);

var _utils = require('../../base/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function FrButton(_ref) {
  var icon = _ref.icon,
      children = _ref.children,
      type = _ref.type,
      rest = _objectWithoutProperties(_ref, ['icon', 'children', 'type']);

  var iconName = void 0;
  switch (icon) {
    case 'delete':
      iconName = 'ashbin';
      break;
    default:
      iconName = icon;
      break;
  }

  var restProps = type === 'dashed' ? rest : _extends({}, rest, { type: type }); // fusion不支持dashed，antd支持，这边强兼容一下

  return _react2.default.createElement(
    _next.Button,
    restProps,
    iconName ? _react2.default.createElement(_next.Icon, { type: iconName }) : null,
    children
  );
}

var List = (0, _listHoc2.default)(FrButton);

var ListWithModal = function ListWithModal(props) {
  var _ref2 = props || {},
      options = _ref2.options,
      schema = _ref2.schema,
      value = _ref2.value;

  var arrLength = value && value.length || 0;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      show = _useState2[0],
      setShow = _useState2[1];

  var toggle = function toggle() {
    return setShow(function (o) {
      return !o;
    });
  };
  if (options && options.modal) {
    var config = (0, _utils.isObj)(options.modal) ? options.modal : {};
    var text = config.text;

    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        'a',
        { className: 'pointer link', onClick: toggle },
        text && typeof text === 'string' ? '+ ' + text : '+ 配置'
      ),
      _react2.default.createElement(
        'span',
        { style: { fontSize: 14 } },
        '\uFF08',
        arrLength,
        '\u6761\u6570\u636E\uFF09'
      ),
      _react2.default.createElement(
        _next.Dialog,
        _extends({
          className: 'fr-wrapper',
          title: schema && schema.title || '子配置',
          visible: show,
          onClose: toggle,
          footerActions: ['ok'],
          onOk: toggle,
          height: '80%'
        }, config, {
          style: _extends({
            maxWidth: 800,
            width: '80%',
            overflow: 'auto'
          }, config.style)
        }),
        _react2.default.createElement(
          'div',
          { className: 'fr-wrapper' },
          _react2.default.createElement(List, props)
        )
      )
    );
  }
  if (options && options.drawer) {
    var _config = (0, _utils.isObj)(options.drawer) ? options.drawer : {};
    var _text = _config.text;

    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        'a',
        { className: 'pointer link', onClick: toggle },
        _text && typeof _text === 'string' ? '+ ' + _text : '+ 配置'
      ),
      _react2.default.createElement(
        _next.Drawer,
        _extends({
          title: schema && schema.title || '子配置',
          visible: show,
          onClose: toggle,
          width: '80%'
        }, _config),
        _react2.default.createElement(
          'div',
          { className: 'fr-wrapper' },
          _react2.default.createElement(List, props)
        )
      )
    );
  }
  return _react2.default.createElement(List, props);
};

exports.default = ListWithModal;